#ifndef __CArray_ph__
#define __CArray_ph__

void CArrayAdd (CArray This, void* object);
void CArrayCleanup ();
void CArrayCheck();
int CArrayCount (CArray This);
void CArrayErase (CArray This);
void* CArrayFind (CArray This, void* object);
CIterator CArrayGiveBackwardIterator (CArray This);
CIterator CArrayGiveIterator (CArray This);
CArray CArrayNew ();
void* CArrayItem (CArray This, CIterator it);
void CArrayRemove (CArray This, void* object);

CHasher CHasherNew (int size,
                    CValuator valuator,
                    CCoder coder,
                    CTester tester);
void CHasherErase (CHasher This);
void CHasherAdd (CHasher This, void* object);
void* CHasherFind (CHasher This, void* value);
void CHasherRemove (CHasher This, void* object);
CIterator CHasherGiveIterator (CHasher This);

int CIteratorFinished (CIterator This);
void CIteratorFirst (CIterator This);
void CIteratorForth (CIterator This);
void CIteratorDelete (CIterator This);
void* CIteratorItem (CIterator This);
void CIteratorStop (CIterator This);

CLList CLListNew ();
void CLListErase (CLList This);
int CLListCount (CLList This);
void CLListAdd (CLList This, void* object);
void CLListPrepend (CLList This, void* object);
void* CLListFirst (CLList This);
void* CLListLast (CLList This);
void CLListRemove (CLList This, void* object);
void* CLListFind (CLList This, void* object);
CIterator CLListGiveIterator (CLList This);
CIterator CLListGiveBackwardIterator (CLList This);

int CQueueCount (CQueue This);
void CQueueErase (CQueue This);
CQueue CQueueNew ();
void* CQueuePop (CQueue This);
void CQueuePush (CQueue This, void* object);
void* CQueueTop (CQueue This);

CHasher CPtrHasherNew (int size, CValuator valuator);

int CStackCount (CStack This);
void CStackErase (CStack This);
CStack CStackNew ();
void* CStackPop (CStack This);
void CStackPush (CStack This, void* object);
void* CStackTop (CStack This);

CHasher CStrHasherNew (int size, CValuator valuator);
CHasher CLStrHasherNew (int size, CValuator valuator);

#endif /* __CArray_ph__ */
